//+------------------------------------------------------------------+
//|                                                   Statistica.mq4 |
//|                              Copyright  2009, Nazariy S. (WWer) |
//|                   E-mail: wholewer@gmail.com, Skype: nazariy1309 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, Nazariy S. (WWer)"
#property link      "E-mail: wholewer@gmail.com, Skype: nazariy1309"

double Mediana(double arr[]) // 
  {
   double res=0.0;
   int size=ArraySize(arr);
   if(size%2==0)
      res=(arr[size/2-1]+arr[size/2])/2;
   else res=arr[(size+1)/2-1];
   return(res);
  }

double Mediana50(double arr[]) //  50%-   ( )
  {
   int size=ArraySize(arr),
       m=size/4;
   return((arr[m]+arr[size-m-1])/2);
  }

double Average(double arr[]) //     
  {
   int size=ArraySize(arr);
   double Sum=0.0;
   for(int i=0; i<size; i++)
       Sum+=arr[i];
   return(Sum/size);
  }

double Average50(double arr[]) //    50%-  
  {
   double Sum=0.0;
   int size=ArraySize(arr),
       m=size/4,
       n=size-m;
   for(int i=m; i<n; i++)
       Sum+=arr[i];
   return(Sum/(size-2*m));
  }

double Center(double arr[]) //  
  {
   double res=0.0;
   int size=ArraySize(arr);
   res=(arr[0]+arr[size-1])/2;
   return(res);
  }

double Xcenter(double arr[]) //     
  {
   double array[5];
   array[0]=Mediana(arr);
   array[1]=Mediana50(arr);
   array[2]=Average(arr);
   array[3]=Average50(arr);
   array[4]=Center(arr);
   ArraySort(array);
   return(array[2]);
  }

double DX(double arr[], double MX) // 
  {
   int size=ArraySize(arr);
   double Sum=0.0;
   for(int i=0; i<size; i++)
       Sum+=MathPow(arr[i]-MX,2);
   return(Sum/(size-1));
  }

double m3(double arr[], double MX) // 3-  
  {
   int size=ArraySize(arr);
   double Sum=0.0;
   for(int i=0; i<size; i++)
       Sum+=MathPow(arr[i]-MX,3);
   return(size/(size-1)/(size-2)*Sum);
  }

double m4(double arr[], double MX) // 4-  
  {
   double Sum2=0.0,
          Sum4=0.0;
   int size=ArraySize(arr);
   for(int i=0; i<size; i++) {
       Sum2+=MathPow(arr[i]-MX,2);
       Sum4+=MathPow(arr[i]-MX,4);
      }
   return(((MathPow(size,2)-2*size+3)*Sum4-
          (6*size-9)/size*MathPow(Sum2,2))/
          (size-1)*(size-2)*(size-3));
  }

double A(double arr[], double MX, double DX) //  
  {
   double Sum=0.0,
          size=ArraySize(arr);
   for(int i=0; i<size; i++)
       Sum+=MathPow(arr[i]-MX,3);
   return(size/(size-1)/(size-2)/MathPow(DX,1.5)*Sum);
  }

double E2(double arr[], double MX, double DX) //  (  )
  {
   double Sum2=0.0,
          Sum4=0.0,
          size=ArraySize(arr);
   for(int i=0; i<size; i++) {
       Sum2+=MathPow(arr[i]-MX,2);
       Sum4+=MathPow(arr[i]-MX,4);
      }
   return((size*(size+1)*Sum4-3*Sum2*Sum2*(size-1))/(size-1)/(size-2)/(size-3)/DX/DX);
  }

double E(double arr[], double MX, double DX) // 
  {
   double Sum=0.0,
          size=ArraySize(arr);
   for(int i=0; i<size; i++)
       Sum+=MathPow(arr[i]-MX,4);
   return(((MathPow(size,2)-2*size+3)/(size-1)/DX*DX*Sum-
          (6*size-9)*(size-1)/size)/(size-2)/(size-3));
  }

double Gamma(double x) // -   x>0
  {
        double p = 0.0,
               pp = 0.0,
               qq = 0.0,
               z = 1.0,
               sgngam = 1.0;
        int    i = 0;

        if( x>33.0 )
            return(sgngam*gammastirf(x));
        while( x>=3 ) {
            x--;
            z = z*x;
           }
        while( x<2 ) {
            if( x<0.000000001 )
                return(z/((1+0.5772156649015329*x)*x));
            z/=x;
            x++;
           }
        if( x==2 )
            return(z);
        x-=2.0;
        pp = 0.000160119522476751861407;
        pp = 0.00119135147006586384913+x*pp;
        pp = 0.0104213797561761569935+x*pp;
        pp = 0.0476367800457137231464+x*pp;
        pp = 0.207448227648435975150+x*pp;
        pp = 0.494214826801497100753+x*pp;
        pp = 0.999999999999999996796+x*pp;
        qq = -0.0000231581873324120129819;
        qq = 0.000539605580493303397842+x*qq;
        qq = -0.00445641913851797240494+x*qq;
        qq = 0.0118139785222060435552+x*qq;
        qq = 0.0358236398605498653373+x*qq;
        qq = -0.234591795718243348568+x*qq;
        qq = 0.0714304917030273074085+x*qq;
        qq = 1.00000000000000000320+x*qq;
        return(z*pp/qq);
  }

double gammastirf(double x) //  ,    -   x>33
  {
   double y = 0.0,
          w = 0.0,
          v = 0.0,
          stir = 0.0;
   //--------
   w = 1.0/x;
   stir = 0.000787311395793093628397;
   stir = -0.000229549961613378126380+w*stir;
   stir = -0.00268132617805781232825+w*stir;
   stir = 0.00347222221605458667310+w*stir;
   stir = 0.0833333333333482257126+w*stir;
   w = 1+w*stir;
   y = MathExp(x);
   if(x>143.01608) {
      v = MathPow(x, 0.5*x-0.25);
      y = v*(v/y);
     }
   else y = MathPow(x, x-0.5)/y;
   return(2.50662827463100050242*y*w);
  }

double DDX(double arr[], double m4, double DX) //   
  {
   return((m4-MathPow(DX,2))/ArraySize(arr));
  }

double Dsig(double arr[], double m4, double DX) //     
  {
   return(DDX(arr,m4,DX)/DX/4);
  }

double DA(double size) //   
  {
   return((6*size-6)/(size+1)/(size+3));
  }

double DE(double size) //   
  {
   return(24*size*(size-2)*(size-3)/
          MathPow(size-1,2)/(size+3)/(size+5));
  }

double DMX(double DX, int size) //    
  {
   return(DX/size);
  }

double Log(double x, double a) //     
  {
   return(MathLog(x)/MathLog(a));
  }

double G(int size, double E) //  
  {
   return(1.55+0.8*Log(1.0*size/10,10)*MathSqrt(E-1));
  }

int L(double E, int size) //      
  {
   int n=(E/6+0.25)*MathPow(size,0.4);
   if(n%2==0) n--;
   return(n);
  }

int Resize(double& arr[], double G, double DX, double Xcenter) //    
  {
   int    mini=-1,
          maxi=-1,
          m=0,
          size=ArraySize(arr);
   double sig=MathSqrt(DX),
          Gsig=G*sig,
          min=Xcenter-Gsig,
          max=Xcenter+Gsig;
   for(int i=size-1; maxi<0; i--)
       if(arr[i]<=max)
          maxi=size-1-i;
   for(i=0; mini<0; i++)
       if(arr[i]>=min)
          mini=i;
   m=size-mini-maxi;
   for(i=0; i<m; i++)
       arr[i]=arr[i+mini];
   return(ArrayResize(arr,m));
  }

void Histogram(double& arr[]) //     *.csv (   Excel)
  {
   double Xcenter=0.0,
          MX=0.0,
          Xmin=0.0,
          Xmax=0.0,
          delta=0.0,
          max=0.0,
          d=0.0,    //   
          DX=0.0,
          A=0.0,
          E=0.0,
          G=0.0,
          S=0.0,    //    (=d*size)
          histog[];
   int    size=ArraySize(arr),
          L=0,        //    ()
          Int=0,
          handle=0;
   ArraySort(arr);
   Xcenter=Xcenter(arr);
   DX=DX(arr,Xcenter);
   E=E2(arr,Xcenter,DX);
   G=G(size,E);
   size=Resize(arr,G,DX,Xcenter);
   MX=Average(arr);
   DX=DX(arr,MX);
   A=A(arr,MX,DX);
   E=E2(arr,MX,DX);
   L=L(E,size);
   max=MathMax(MathAbs(arr[0]-MX),MathAbs(arr[size-1]-MX));
   Xmin=MX-max;
   Xmax=MX+max;
   d=2*max/L;
   delta=Xmax-Xmin;
   ArrayResize(histog,L);
   ArrayInitialize(histog,0.0);
   for(int i=0; i<size; i++) {
       Int=(arr[i]-Xmin)/delta*L;
       if(Int==L) Int--;
       histog[Int]++;
      }
   S=d*size;
   for(i=0; i<L; i++)
       histog[i]/=S;
   if(MathAbs(A)/MathSqrt(DA(size))<3)
      for(i=0; i<L/2; i++) {
          histog[i]=(histog[i]+histog[L-1-i])/2;
          histog[L-1-i]=histog[i];
         }
   //----
   handle=FileOpen("histogram.csv", FILE_CSV|FILE_WRITE);
   for(i=0; i<L; i++)
       FileWrite(handle,histog[i]);
   FileClose(handle);
  }

double cov(double arrX[], double arrY[], double MX, double MY) //  
  {
   double Sum=0.0;
   int size=ArraySize(arrX);
   for(int i=0; i<size; i++)
       Sum+=(arrX[i]-MX)*(arrY[i]-MY);
   return(Sum/(size-1));
  }

double p(double cov, double DX, double DY) //   
  {
   return(cov/MathSqrt(DX)/MathSqrt(DY));
  }

double Dp(double p, int size) //   
  {
   return(MathPow(1.0-MathPow(p,2),2)/(size-1));
  }

double AutoKorel(double arr[], double MX, int por) //   por
  {
   int    size=ArraySize(arr)-por;
   double Sum1=0.0,
          Sum2=0.0,
          Sum3=0.0;
   for(int i=0; i<size; i++) {
       Sum1+=(arr[i]-MX)*(arr[i+por]-MX);
       Sum2+=MathPow(arr[i]-MX,2);
       Sum3+=MathPow(arr[i+por]-MX,2);
      }
   return(Sum1/MathSqrt(Sum2)/MathSqrt(Sum3));
  }

void AutoKorelFunc(double arr[], double MX, int count, double& res[]) //   ()
  {
   int    size=ArraySize(arr);
   double Sum1=0.0,
          Sum2=0.0;
   count++;
   ArrayResize(res,count);
   res[0]=1.0;
   for(int i=1; i<count; i++)
       res[i]=AutoKorel(arr,MX,i);
  }

double a(double p, double sigX, double sigY) //  a     y=a*x+b
  {
   return(p*sigY/sigX);
  }

double b(double MX, double MY, double a) //  b     y=a*x+b
  {
   return(MY-a*MX);
  }

void e(double arrX[], double arrY[], double a, double b, double& e[]) //    e[]   
  {
   int size=ArraySize(arrX);
   ArrayResize(e,size);
   for(int i=0; i<size; i++)
       e[i]=arrY[i]-a*arrX[i]-b;
  }

double De(double e[]) //    -     (,  Me=0)
  {
   double Sum=0.0;
   int size=ArraySize(e);
   for(int i=0; i<size; i++)
       Sum+=MathPow(e[i],2);
   return(Sum/(size-2));
  }

double Da(int size, double DX, double De) //        y=a*x+b
  {
   return(De/DX/(size-1));
  }

double Db(double arrX[], double DX, double De) //   b     y=a*x+b
  {
   int    size=ArraySize(arrX);
   double Sum=0.0;
   for(int i=0; i<size; i++)
       Sum+=MathPow(arrX[i],2);
   return(De*(size-1)*Sum/DX/size);
  }

double R2(int size, double DY, double De) //  
  {
   return(1.0-De*(size-2)/DY/(size-1));
  }

void Roz(double arr[][], double& arrX[], double& arrY[]) //    arr[n][2]   
  {
   int size=ArraySize(arr)/2;
   ArrayResize(arrX,size);
   ArrayResize(arrY,size);
   for(int i=0; i<size; i++) {
       arrX[i]=arr[i][0];
       arrY[i]=arr[i][1];
      }
  }

void Ob(double arrX[], double arrY[], double& arr[][]) //       arr[n][2]
  {
   int size=ArraySize(arrX);
   ArrayResize(arr,size*2);
   for(int i=0; i<size; i++) {
       arr[i][0]=arrX[i];
       arr[i][1]=arrY[i];
      }
  }

void WriteArray(double arr[], string name="") //     *.csv 
  {
   if(name=="") name=TimeToStr(TimeLocal(),TIME_DATE|TIME_SECONDS);
   int handle=FileOpen(name+".csv", FILE_CSV|FILE_WRITE),
       size=ArraySize(arr);
   for(int i=0; i<size; i++)
       FileWrite(handle,DoubleToStr(arr[i],8));
   FileClose(handle);
  }

void WriteArray2(double arr[][], string name="") //     *.csv 
  {
   if(name=="") name=TimeToStr(TimeLocal(),TIME_DATE|TIME_SECONDS);
   int handle=FileOpen(name+".csv", FILE_CSV|FILE_WRITE),
       size=ArraySize(arr)/2;
   for(int i=0; i<size; i++)
       FileWrite(handle,DoubleToStr(arr[i][0],8),DoubleToStr(arr[i][1],8));
   FileClose(handle);
  }

//+------------------------------------------------------------------+
//| defines                                                          |
//+------------------------------------------------------------------+
// #define MacrosHello   "Hello, world!"
// #define MacrosYear    2005

//+------------------------------------------------------------------+
//| DLL imports                                                      |
//+------------------------------------------------------------------+
// #import "user32.dll"
//   int      SendMessageA(int hWnd,int Msg,int wParam,int lParam);

// #import "my_expert.dll"
//   int      ExpertRecalculate(int wParam,int lParam);
// #import

//+------------------------------------------------------------------+
//| EX4 imports                                                      |
//+------------------------------------------------------------------+
// #import "stdlib.ex4"
//   string ErrorDescription(int error_code);
// #import
//+------------------------------------------------------------------+